#declare MF_MandibleCentre = object {
	intersection {
		object {box {<-14.7,-0.9,0>, <0,0.9,40>} rotate <0,23,0>}
		object {box {<-20,-2,0>, <-2.5,2,28>}}
		object {cylinder {<-7.5,-3,16>, <-7.5,3,16>, 1.5} inverse}
		object {cylinder {<-5,-3,22>, <-5,3,22>, 1.5} inverse}
	}
}
#declare MF_MandibleTop = object {
	union {
		object {
			intersection {
				object {box {<-15.1,0.9,0>, <0,1,40>} rotate <0,23,0>}
				object {box {<-20,-2,0>, <-2.4,2,28>}}
				object {cylinder {<-7.5,0,16>, <-7,2,16>, 1.2} inverse}
				object {cylinder {<-5,0,22>, <-5,2,22>, 1.2} inverse}
			}
			texture {
				MF_HullTexFlatGrey
				normal {
					bump_map {gif "platemap2.gif" bump_size 1}
					rotate <90,0,0>
					scale 12
				}
			}
		}
		/* Following lines are detail on top of inside edge of mandibles */
		object {box {<-2.6, 1, 23>, <-2.5, 1.5, 27.8>}}
		object {
			intersection {
				object {box {<-2.6,1,22>, <-2.5,1.5,27.8>}}
				object {cone {<0,1,0>, 1, <0,1.5,0>, 0} scale <10,1,1> translate <-2.6,0,23>}
			}
		}
		object {box {<-3.5, 1, 27.1>, <-2.6,1.3,27.9>}}
		object {box {<-3.5, 1, 27.6>, <-2.6,1.5,27.9>}}
		object {cylinder {<-3,1.4,27.1>, <-3,1.3,27.8>, 0.05}}
		object {cylinder {<-3.2,1.4,27.1>, <-3.2,1.3,27.8>, 0.05}}
		object {cylinder {<-3,1,10>, <-3,1,28>, 0.05}}
		object {cylinder {<-2.7,1,10>, <-2.7,1,28>, 0.05}}
	}
}

#declare MF_MandibleBottom = object {
	union {
		object {
			intersection {
				object {box {<-15.1,0.9,0>, <0,1,40>} rotate <0,23,0>}
				object {box {<-20,-2,0>, <-2.4,2,28>}}
				object {cylinder {<-7.5,0,16>, <-7,2,16>, 1.2} inverse}
				object {cylinder {<-5,0,22>, <-5,2,22>, 1.2} inverse}
			}
			texture {
				MF_HullTexFlatGrey
				normal {
					bump_map {gif "platemap2.gif" bump_size 1}
					rotate <90,0,0>
					scale 12
				}
			}
		}
		object {box {<-2.6, 1, 23>, <-2.5, 1.5, 27.8>}}
		object {
			intersection {
				object {box {<-2.6,1,22>, <-2.5,1.5,27.8>}}
				object {cone {<0,1,0>, 1, <0,1.5,0>, 0} scale <10,1,1> translate <-2.6,0,23>}
			}
		}
	}
	scale <1,-1,1>
}

#declare MF_LeftMandibleSideDetail = object {
	height_field {gif "mflmhf.gif"}
	translate <-0.5,0,-0.5>
	rotate <0,90,0>
	scale <1.8,0.4,19>
	rotate <0,0,90>
	translate <0,0,14>
	translate <-14.701,0,0>
	rotate <0,23,0>
}

#declare MF_RightMandibleSideDetail = object {
	height_field {gif "mfrmhf.gif"}
	translate <-0.5,0,-0.5>
	rotate <0,90,0>
	scale <1.8,0.4,19>
	rotate <0,0,90>
	translate <0,0,14>
	translate <-14.701,0,0>
	rotate <0,23,0>
	scale <-1,1,1>
}


#declare MF_MandibleCommonDetail = object {
	union {
		object { // Detail on front end of mandibles
			union {
				object {box {<2.5,-0.8,27.9>, <4.5,0.8,28.001>}}
				object {box {<2.5,-0.4,28>, <4.5,0.4,28.1>}}
				#declare Count = -0.375
				#while (Count <0.4) 
				object {cylinder {<2.5,Count,28.1>, <4.5,Count,28.1>, 0.08}}
				#declare Count = Count + 0.1
				#end
				object {
					union {
						object {torus {0.1,0.05} rotate <90,0,0> translate <2.7,0.6,28>}
						object {torus {0.1,0.05} rotate <90,0,0> translate <3.0,0.6,28>}
						object {torus {0.1,0.05} rotate <90,0,0> translate <3.3,0.6,28>}
						object {torus {0.1,0.05} rotate <90,0,0> translate <3.6,0.6,28>}
						object {torus {0.1,0.05} rotate <90,0,0> translate <3.9,0.6,28>}
						object {torus {0.1,0.05} rotate <90,0,0> translate <4.2,0.6,28>}
					}
				}
				object {
					union {
						object {torus {0.1,0.05} rotate <90,0,0> translate <2.7,-0.6,28>}
						object {torus {0.1,0.05} rotate <90,0,0> translate <3.0,-0.6,28>}
						object {torus {0.1,0.05} rotate <90,0,0> translate <3.3,-0.6,28>}
						object {torus {0.1,0.05} rotate <90,0,0> translate <3.6,-0.6,28>}
						object {torus {0.1,0.05} rotate <90,0,0> translate <3.9,-0.6,28>}
						object {torus {0.1,0.05} rotate <90,0,0> translate <4.2,-0.6,28>}
					}
				}
			}
		}
			
		object { // Detail along inside edge of mandibles
			union {
				object {cylinder {<0, 0, 21>, <0.1, 0, 21>, 0.5}}
				object {cylinder {<0, 0, 21>, <0.2, 0, 21>, 0.3}}
				object {cylinder {<0,0,21>, <0,0,27>, 0.1} texture {MF_HardwareTex1}}
				object {cylinder {<0,0.5,24>, <0,0.5,26>, 0.2}}
				object {sphere {<0,0.5,26>, 0.2}}
				object {cylinder {<0,-0.5,24>, <0,-0.5,26>, 0.2}}
				object {sphere {<0,-0.5,26>, 0.2}}
				object {cylinder {<0,-0.5,26>, <0,0.5,26>, 0.1}}
				object {cylinder {<0,-0.2,26>, <0,0.2,26>, 0.2} texture {MF_HullTexDarkGrey}}
				object {
					intersection {
						object {cone {<0,0,27>, 0.6, <0.3,0,27>, 0.2} scale <1,10,1>}
						object {box {<0,-0.2,25>, <0.299,0.2,28>}}
					}
				}
				
			}
			scale <-1,1,1>
			translate <2.5,0,0>
		}
		object {
			union {
				object {cylinder {<0,0,0>, <0,0,-20>, 0.05}}
				object {sphere {<0,0,0>, 0.06}}
				object {sphere {<0,0,-20>, 0.06}}
			}
			rotate <0,-23,0>
			translate <4.5,1,27>
			texture {MF_HullTexFlatGrey}
		}
		object {
			union {
				object {cylinder {<0,0,0>, <0,0,-5>, 0.05}}
				object {sphere {<0,0,0>, 0.06}}
				object {sphere {<0,0,-5>, 0.06}}
				object {cylinder {<0,0,0>, <0,-1,0>, 0.05}}
				object {cylinder {<0,0,-5>, <0,-1,-5>, 0.05}}
			}
			rotate <0,-23,0>
			translate <5,1,21>
			texture {MF_ChromeMetal}
		}
		object {
			union {
				object {cylinder {<0,0,0>, <0,0,2>, 0.05}}
				object {cylinder {<0,-1,0>, <0,0,0>, 0.05}}
				object {cylinder {<0,0,0>, <0,0,2>, 0.05} rotate <0,32,0> translate <0,0,2>}
				object {sphere {<0,0,0>, 0.075}}
				object {sphere {<0,0,2>, 0.075} rotate <0,32,0> translate <0,0,2>}
				object {sphere {<0,0,2>, 0.075}}
			}
			texture {MF_GunMetal1}
			rotate <0,-32,0>
			translate <5,1,23>
		}
		object { // Assorted other detail on mandibles
			union {
				object {box {<-0.3,0.8,1.1>, <0.2,0.9,1.35>}}
				object {
					intersection {
						object {
							union {
								object {cone {<0,0,1.4>, 0.3, <0,0.8,1.4>, 0.01}}
								object {cylinder {<0,0,0.9>, <0,0.8,0.9>, 0.5}}
								object {cone {<0,0,0.4>, 1, <0,0.8,0.4>, 0.01}}
								object {cylinder {<0,0,0>, <0,0.3,0>, 0.5}}
								object {cylinder {<0,0,-1>, <0,0.5,-1>, 0.5}}
								object {cone {<0,0,-1.5>, 1, <0,0.5,-1.5>, 0.001}}
							}
							scale <100,1,1>
						}
						object {cone {<0,0,0>, 0.4, <0,1,0>, 0.2} scale <1,1,100>}
					}
				}
			}
			scale <1,0.8,1>
			translate <5.5,1,16>
		}
	}
	texture {MF_HullTexFlatGrey}
}

#declare MF_RightMandible = object {
	union {
		object {MF_RightMandibleSideDetail}
		object {MF_MandibleCentre scale <-1,1,1>}
		object {MF_MandibleTop scale <-1,1,1>}
		object {MF_MandibleBottom scale <-1,1,1>}
		object {MF_InternalDetailMFTR translate <5,0,22>}
		object {MF_InternalDetailMFBR translate <5,0,22> scale <1,-1,1>}
		object {MF_InternalDetailMRTR translate <7.5,0,16>}
		object {MF_InternalDetailMRBR translate <7.5,0,16> scale <1,-1,1>}
		object {MF_MandibleCommonDetail}
	}
	texture {MF_HullTexFlatGrey}
}

#declare MF_LeftMandible = object {
	union {
		object {MF_LeftMandibleSideDetail}
		object {MF_MandibleCentre}
		object {MF_MandibleTop}
		object {MF_MandibleBottom}
		object {MF_InternalDetailMFTL translate <-5,0,22>}
		object {MF_InternalDetailMFBL translate <-5,0,22> scale <1,-1,1>}
		object {MF_InternalDetailMRTL translate <-7.5,0,16>}
		object {MF_InternalDetailMRBL translate <-7.5,0,16> scale <1,-1,1>}
		object {MF_MandibleCommonDetail scale <-1,1,1>}
	}
	texture {MF_HullTexFlatGrey}
}